# NOTE: Derived from blib/lib/Class/MethodMaker.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Class::MethodMaker;

#line 1418 "blib/lib/Class/MethodMaker.pm (autosplit into blib/lib/auto/Class/MethodMaker/static_hash.al)"
# ----------------------------------------------------------------------


sub static_hash {
  my ($class, @args) = @_;
  my %methods;

  foreach (@args) {
    my $field = $_;
    my %hash;

    $methods{$field} =
      sub {
	my ($class, @list) = @_;
	if (scalar @list == 1) {
	  my $key = shift @list;
	  if (ref $key) { # had better by an array ref
	    return @hash{@$key};
	  } else {
	    return $hash{$key};
	  }
	} else {
	  while (1) {
	    my $key = shift @list;
	    defined $key or last;
	    my $value = shift @list;
	    defined $value or carp "No value for key $key.";
	    $hash{$key} = $value;
	  }
	  %hash;
	}
      };

    $methods{"$ {field}s"} = $methods{$field};

    $methods{$field . "_keys"} =
      sub {
	my ($class) = @_;
	keys %hash;
      };

    $methods{$field . "_values"} =
      sub {
	my ($class) = @_;
	values %hash;
      };

    $methods{$field . "_exists"} =
      sub {
	my ($class) = shift;
	my ($key) = @_;
	return
	  exists $hash{$key};
      };

    $methods{$field . "_tally"} =
      sub {
	my ($class, @list) = @_;
	map { ++$hash{$_} } @list;
      };

    $methods{"add_$field"} =
      sub {
	my ($class, $attrib, $value) = @_;
	$hash{$attrib} = $value;
      };

    $methods{"clear_$field"} =
      sub {
	my ($class, $attrib) = @_;
	delete $hash{$attrib};
      };

    $methods{"add_$ {field}s"} =
      sub {
	my ($class, %attribs) = @_;
	my ($k, $v);
	while (($k, $v) = each %attribs) {
	  $hash{$k} = $v;
	}
      };

    $methods{"clear_$ {field}s"} =
      sub {
	my ($class, @attribs) = @_;
	my $attrib;
	foreach $attrib (@attribs) {
	  delete $hash{$attrib};
	}
      };
  }
  $class->install_methods(%methods);
}

# end of Class::MethodMaker::static_hash
1;
